/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoTmxUtilConvert]のクラス
 */
package blanco.tmx.util.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.tmx.util.task.valueobject.BlancoTmxUtilConvertProcessInput;

/**
 * Apache Antタスク [BlancoTmxUtilConvert]のクラス。
 *
 * [TMX対応ツール] TMXファイルを所定のルールで変換します。<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.tmx.util.task]にBlancoTmxUtilConvertBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blancotmxutilconvert&quot; classname=&quot;blanco.tmx.util.task.BlancoTmxUtilConvertTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoTmxUtilConvertTask extends Task {
    /**
     * [TMX対応ツール] TMXファイルを所定のルールで変換します。
     */
    protected BlancoTmxUtilConvertProcessInput fInput = new BlancoTmxUtilConvertProcessInput();

    /**
     * [TMX対応ツール] TMXファイルを所定のルールで変換します。
     */
    protected boolean fIsFieldSourcedirProcessed = false;

    /**
     * [TMX対応ツール] TMXファイルを所定のルールで変換します。
     */
    protected boolean fIsFieldTargetdirProcessed = false;

    /**
     * [TMX対応ツール] TMXファイルを所定のルールで変換します。
     */
    protected boolean fIsFieldIsindentxmlProcessed = false;

    /**
     * [TMX対応ツール] TMXファイルを所定のルールで変換します。
     */
    protected boolean fIsFieldEncodingProcessed = false;

    /**
     * [TMX対応ツール] TMXファイルを所定のルールで変換します。
     */
    protected boolean fIsFieldAdjustlangProcessed = false;

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final boolean arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public boolean getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[sourcedir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * TMXファイルが格納されている入力先ルート・フォルダを指定します。<br>
     *
     * @param arg セットしたい値
     */
    public void setSourcedir(final String arg) {
        fInput.setSourcedir(arg);
        fIsFieldSourcedirProcessed = true;
    }

    /**
     * Antタスクの[sourcedir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * TMXファイルが格納されている入力先ルート・フォルダを指定します。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getSourcedir() {
        return fInput.getSourcedir();
    }

    /**
     * Antタスクの[targetdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * TMXファイルが格納される出力先ルート・フォルダを指定します。<br>
     *
     * @param arg セットしたい値
     */
    public void setTargetdir(final String arg) {
        fInput.setTargetdir(arg);
        fIsFieldTargetdirProcessed = true;
    }

    /**
     * Antタスクの[targetdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * TMXファイルが格納される出力先ルート・フォルダを指定します。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTargetdir() {
        return fInput.getTargetdir();
    }

    /**
     * Antタスクの[isindentxml]アトリビュートのセッターメソッド。
     *
     * 項目番号: 3<br>
     * XMLをインデントするかどうか。<br>
     *
     * @param arg セットしたい値
     */
    public void setIsindentxml(final boolean arg) {
        fInput.setIsindentxml(arg);
        fIsFieldIsindentxmlProcessed = true;
    }

    /**
     * Antタスクの[isindentxml]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 3<br>
     * XMLをインデントするかどうか。<br>
     * デフォルト値[true]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getIsindentxml() {
        return fInput.getIsindentxml();
    }

    /**
     * Antタスクの[encoding]アトリビュートのセッターメソッド。
     *
     * 項目番号: 4<br>
     * XMLエンコーディング。<br>
     *
     * @param arg セットしたい値
     */
    public void setEncoding(final String arg) {
        fInput.setEncoding(arg);
        fIsFieldEncodingProcessed = true;
    }

    /**
     * Antタスクの[encoding]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 4<br>
     * XMLエンコーディング。<br>
     *
     * @return このフィールドの値
     */
    public String getEncoding() {
        return fInput.getEncoding();
    }

    /**
     * Antタスクの[adjustlang]アトリビュートのセッターメソッド。
     *
     * 項目番号: 5<br>
     * lang を調整するかどうか? 翻訳ブレインが処理できるように加工するにはこれを true にセット。<br>
     *
     * @param arg セットしたい値
     */
    public void setAdjustlang(final boolean arg) {
        fInput.setAdjustlang(arg);
        fIsFieldAdjustlangProcessed = true;
    }

    /**
     * Antタスクの[adjustlang]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 5<br>
     * lang を調整するかどうか? 翻訳ブレインが処理できるように加工するにはこれを true にセット。<br>
     * デフォルト値[false]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getAdjustlang() {
        return fInput.getAdjustlang();
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    public final void execute() throws BuildException {
        System.out.println("BlancoTmxUtilConvertTask begin.");

        // 項目番号[1]、アトリビュート[sourcedir]は必須入力です。入力チェックを行います。
        if (fIsFieldSourcedirProcessed == false) {
            throw new BuildException("必須アトリビュート[sourcedir]が設定されていません。処理を中断します。");
        }
        // 項目番号[2]、アトリビュート[targetdir]は必須入力です。入力チェックを行います。
        if (fIsFieldTargetdirProcessed == false) {
            throw new BuildException("必須アトリビュート[targetdir]が設定されていません。処理を中断します。");
        }

        if (getVerbose()) {
            System.out.println("- verbose:[true]");
            System.out.println("- sourcedir:[" + getSourcedir() + "]");
            System.out.println("- targetdir:[" + getTargetdir() + "]");
            System.out.println("- isindentxml:[" + getIsindentxml() + "]");
            System.out.println("- encoding:[" + getEncoding() + "]");
            System.out.println("- adjustlang:[" + getAdjustlang() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            // この箇所でコンパイルエラーが発生する場合、BlancoTmxUtilConvertProcessインタフェースを実装して blanco.tmx.util.taskパッケージに BlancoTmxUtilConvertProcessImplクラスを作成することにより解決できる場合があります。
            final BlancoTmxUtilConvertProcess proc = new BlancoTmxUtilConvertProcessImpl();
            if (proc.execute(fInput) != BlancoTmxUtilConvertBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if (getVerbose()) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
